﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=9
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Public bmp1, bmp2, bmp3, bmp4, bmp5, bmp6, bmp7 As B4XBitmap
	
	Private Gradient1, Gradient2, Gradient3, Gradient4, Gradient5, Gradient6, Gradient7 As BitmapCreator
	Private Brush1, Brush2, Brush3, Brush4, Brush5, Brush6, Brush7 As BCBrush
	Public bc1, bc2, bc3, bc4, bc5, bc6, bc7 As BitmapCreator
	
	Private LastColorRoundedBorder1a, LastColorRoundedBorder1b, LastColorRoundedBorder2a, LastColorRoundedBorder2b  As Int
	Private LastColorAnalogBackground As Int
	Private LastColorDigitalBackground1, LastColorDigitalBackground2 As Int
	Private LastColorCircleBorder1a, LastColorCircleBorder1b, LastColorCircleBorder2a, LastColorCircleBorder2b As Int
	Private LastColorCircleBackground1, LastColorCircleBackground2 As Int
	
	Private LastWidthRoundedBorder1, LastHeightRoundedBorder1 As Int
	Private LastWidthRoundedBorder2, LastHeightRoundedBorder2 As Int
	Private LastWidthAnalogBackground, LastHeightAnalogBackground As Int
	Private LastWidthDigitalBackground, LastHeightDigitalBackground As Int
	Private LastWidthCircleBorder1, LastHeightCircleBorder1 As Int
	Private LastWidthCircleBorder2, LastHeightCircleBorder2 As Int
	Private LastWidthCircleBackground, LastHeightCircleBackground As Int
	
	Private LastRadiusRoundedBorder1, LastRadiusRoundedBorder2, LastRadiusAnalogBackground, LastRadiusDigitalBackground As Int
	
End Sub

'Used with Analog and Digital Square Border 1
Sub DrawRoundedAnalogBackgroundandBorder(Width As Int, Height As Int, Radius As Int, Clrs() As Int, clrs2() As Int, AnalogInnerBevel As Boolean, BorderWidth As Int)
	If LastColorRoundedBorder1a = Clrs(0) And LastColorRoundedBorder1b = Clrs(1) And LastWidthRoundedBorder1 = Width And LastHeightRoundedBorder1 = Height And LastRadiusRoundedBorder1 = Radius Then
		Log("Reusing DrawRoundedAnalogBackgroundandBorder")
	Else
			
		'Outter Border
		Gradient1.Initialize(10, Height)
		Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "TOP_BOTTOM")
		Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
		bc1.Initialize(Width, Height)	'First Square
		bc1.DrawRectRounded2(bc1.TargetRect, Brush1, True, 0, Radius)
		
		'Inner Border
		If AnalogInnerBevel = True Then
			Gradient1.Initialize(10, Height)
			Gradient1.FillGradient(Clrs, Gradient1.TargetRect, "BOTTOM_TOP")
			Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
			Dim rectGauge10 As B4XRect
			rectGauge10.Initialize(BorderWidth, BorderWidth, Width - BorderWidth, Height - BorderWidth)
			bc1.DrawRectRounded2(rectGauge10, Brush1, True, 0, Radius)
		End If
		
		'Background
		Gradient1.Initialize(Width, Height)
		Gradient1.FillRadialGradient(clrs2, Gradient1.TargetRect)
		Brush1 = Gradient1.CreateBrushFromBitmapCreator(Gradient1)
		Dim RectGauge11 As B4XRect
		RectGauge11.Initialize(BorderWidth * 2, BorderWidth * 2, Width - BorderWidth * 2, Height - BorderWidth * 2)
		bc1.DrawRectRounded2(RectGauge11, Brush1, True, 0, Radius)
	
		LastColorRoundedBorder1a = Clrs(0)
		LastColorRoundedBorder1b = Clrs(1)
		LastWidthRoundedBorder1 = Width
		LastHeightRoundedBorder1 = Height	
		LastRadiusRoundedBorder1 = Radius
'	bmp1 = bc1.Bitmap
	End If

End Sub
'Used with Analog and Digital Square Border 2
Sub DrawRoundedRectBorder2(Width As Int, Height As Int, Radius As Int, Clrs() As Int, Orientation As String)
	Return
	If LastColorRoundedBorder2a = Clrs(0) And LastColorRoundedBorder2b = Clrs(1) And LastWidthRoundedBorder2 = Width And LastHeightRoundedBorder2 = Height And LastRadiusRoundedBorder2 = Radius Then
		Log("Reusing DrawroundedRectBorder2")
	Else
		Gradient2.Initialize(10, Height)
		Gradient2.FillGradient(Clrs, Gradient2.TargetRect, Orientation)
		Brush2 = Gradient2.CreateBrushFromBitmapCreator(Gradient2)
		Dim r As B4XRect
		r.Initialize(20dip, 20dip, Width, Height)
'		bc1.Initialize(Width, Height)
		bc1.DrawRectRounded2(r, Brush2, True, 0, Radius)
		LastColorRoundedBorder2a = Clrs(0)
		LastColorRoundedBorder2b = Clrs(1)
		LastWidthRoundedBorder2 = Width
		LastHeightRoundedBorder2 = Height
		LastRadiusRoundedBorder2 = Radius
		bmp1 = bc1.Bitmap
'		bmp2 = bc2.Bitmap
	End If
End Sub
'Used with Analog Background (Radial Gradient)
Sub DrawRoundedRectAnalogBackground(Width As Int, Height As Int, Radius As Int, Clrs() As Int)
	Return
	If LastColorAnalogBackground = Clrs(0) And LastWidthAnalogBackground = Width And LastHeightAnalogBackground = Height And LastRadiusAnalogBackground = Radius Then
		Log("Reusing DrawRoundedRectAnalogBackground")
	Else	
		Gradient3.Initialize(Width, Height)
'		Gradient3.FillGradient(Clrs, Gradient3.TargetRect, Orientation)
		Gradient3.FillRadialGradient(Clrs, Gradient3.TargetRect)
		Brush3 = Gradient3.CreateBrushFromBitmapCreator(Gradient3)
		bc3.Initialize(Width, Height)
		bc3.DrawRectRounded2(bc3.TargetRect, Brush3, True, 0, Radius)
		LastColorAnalogBackground = Clrs(0)
		LastWidthAnalogBackground = Width
		LastHeightAnalogBackground = Height
		LastRadiusAnalogBackground = Radius
		bmp3 = bc3.Bitmap
	End If
End Sub
'Used with Digital Square Background (Radial Gradient)
Sub DrawRoundedRectDigitalBackground(Width As Int, Height As Int, Radius As Int, Clrs() As Int)
	If LastColorDigitalBackground1 = Clrs(0) And LastColorDigitalBackground2 = Clrs(1) And LastWidthDigitalBackground = Width And LastHeightDigitalBackground = Height And LastRadiusDigitalBackground = Radius Then
		Log("Reusing DrawRoundedRectDigitalBackground")
	Else
		Gradient4.Initialize(Width, Height)
		Gradient4.FillRadialGradient(Clrs, Gradient4.TargetRect)
		Brush4 = Gradient4.CreateBrushFromBitmapCreator(Gradient4)
		bc4.Initialize(Width, Height)
		bc4.DrawRectRounded2(bc4.TargetRect, Brush4, True, 0, Radius)
		LastColorDigitalBackground1 = Clrs(0)
		LastColorDigitalBackground2 = Clrs(1)
		LastWidthDigitalBackground = Width
		LastHeightDigitalBackground = Height
		LastRadiusDigitalBackground = Radius
		bmp4 = bc4.Bitmap
	End If
End Sub

'need to correct the fraction numbers. 
'Used with Digital Circle Border 1
Sub DrawRadialBorder(Width As Int, Height As Int, Clrs() As Int, Orientation As String)
	If LastColorCircleBorder1a = Clrs(0) And LastColorCircleBorder1b = Clrs(1) And LastWidthCircleBorder1 = Width And LastHeightCircleBorder1 = Height Then
		Log("Reusing DrawRadialBorder")
	Else
		Gradient5.Initialize(10, Height)
		Gradient5.FillGradient(Clrs, Gradient5.TargetRect, Orientation)
		Brush5 = Gradient5.CreateBrushFromBitmapCreator(Gradient5)
		bc5.Initialize(Width, Height)
		Dim xWidth As Float = Floor(Width/2)
		Dim xHeight As Float = Floor(Height/2)
		bc5.DrawCircle2(xWidth, xHeight, xWidth, Brush5, True, 0)
		LastColorCircleBorder1a = Clrs(0)
		LastColorCircleBorder1b = Clrs(1)
		LastWidthCircleBorder1 = Width
		LastHeightCircleBorder1 = Height
		bmp5 = bc5.Bitmap
	End If
End Sub
'Used with Digital Circle Border 2
Sub DrawRadialBorder2(Width As Int, Height As Int, Clrs() As Int, Orientation As String)
	If LastColorCircleBorder2a = Clrs(0) And LastColorCircleBorder2b = Clrs(1) And LastWidthCircleBorder2 = Width And LastHeightCircleBorder2 = Height Then
		Log("Reusing DrawRadialBorder2")
	Else
		Gradient6.Initialize(10, Height)
		Gradient6.FillGradient(Clrs, Gradient6.TargetRect, Orientation)
		Brush6 = Gradient6.CreateBrushFromBitmapCreator(Gradient6)
		bc6.Initialize(Width, Height)
		Dim xWidth As Float = Floor(Width/2)
		Dim xHeight As Float = Floor(Height/2)
		bc6.DrawCircle2(xWidth, xHeight, xWidth, Brush6, True, 0)
		LastColorCircleBorder2a = Clrs(0)
		LastColorCircleBorder2b = Clrs(1)
		LastWidthCircleBorder2 = Width
		LastHeightCircleBorder2 = Height
		bmp6 = bc6.Bitmap
	End If
End Sub
'Used with Digital Circle Background
Sub DrawRadialDigitalBackground(Width As Int, Height As Int, Clrs() As Int)
	If LastColorCircleBackground1 = Clrs(0) And LastColorCircleBackground2 = Clrs(1) And LastWidthCircleBackground = Width And LastHeightCircleBackground = Height Then
		Log("Reusing DrawRadialDigitalBackground")
	Else
		Gradient7.Initialize(Width, Height)
		Gradient7.FillRadialGradient(Clrs, Gradient7.TargetRect)
		Brush7 = Gradient7.CreateBrushFromBitmapCreator(Gradient7)
		bc7.Initialize(Width, Height)
		Dim xWidth As Float = Floor(Width/2)
		Dim xHeight As Float = Floor(Height/2)
		bc7.DrawCircle2(xWidth, xHeight, xWidth, Brush7, True, 0)
		LastColorCircleBackground1 = Clrs(0)
		LastColorCircleBackground2 = Clrs(1)
		LastWidthCircleBackground = Width
		LastHeightCircleBackground = Height
		bmp7 = bc7.Bitmap
	End If
End Sub


